datacache <- new.env(hash=TRUE, parent=emptyenv())

POCRCannotation <- function() showQCData("POCRCannotation", datacache)
POCRCannotation_dbconn <- function() dbconn(datacache)
POCRCannotation_dbfile <- function() dbfile(datacache)
POCRCannotation_dbschema <- function(file="", show.indices=FALSE) dbschema(datacache, file=file, show.indices=show.indices)
POCRCannotation_dbInfo <- function() dbInfo(datacache)

POCRCannotationORGANISM <- "Homo sapiens"

.onLoad <- function(libname, pkgname)
{
    ## Connect to the SQLite DB
    dbfile <- system.file("extdata", "POCRCannotation.sqlite", package=pkgname, lib.loc=libname)
    assign("dbfile", dbfile, envir=datacache)
    dbconn <- dbFileConnect(dbfile)
    assign("dbconn", dbconn, envir=datacache)

    ## Create the OrgDb object
    sPkgname <- sub(".db$","",pkgname)
    txdb <- loadDb(system.file("extdata", paste(sPkgname,
      ".sqlite",sep=""), package=pkgname, lib.loc=libname),
                   packageName=pkgname)    
    dbNewname <- AnnotationDbi:::dbObjectName(pkgname,"ChipDb")
    ns <- asNamespace(pkgname)
    assign(dbNewname, txdb, envir=ns)
    namespaceExport(ns, dbNewname)
        
    ## Create the AnnObj instances
    ann_objs <- createAnnObjs.SchemaChoice("HUMANCHIP_DB", "POCRCannotation", "chip POCRCannotation", dbconn, datacache)
    mergeToNamespaceAndExport(ann_objs, pkgname)
    packageStartupMessage(AnnotationDbi:::annoStartupMessages("POCRCannotation.db"))
}

.onUnload <- function(libpath)
{
    dbFileDisconnect(POCRCannotation_dbconn())
}

